Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.owasp.dependencycheck.dependency
Class Vulnerability

    java.lang.Object
      org.owasp.dependencycheck.dependency.Vulnerability

All Implemented Interfaces:
  Serializable, Comparable<Vulnerability>

    public class Vulnerability

extends Object
implements Serializable, Comparable<Vulnerability>

Contains the information about a vulnerability.

Author:
  Jeremy Long (jeremy.long@owasp.org)
See Also:
  Serialized Form

Constructor Summary
`Vulnerability()`

Method Summary
`void` | `addReference(Reference ref)` Adds a reference to the references collection.
`void` | `addReference(String referenceSource, String referenceName, String referenceUrl)` Adds a reference.
`boolean` | `addVulnerableSoftware(String cpe)` Adds an entry for vulnerable software.
`boolean` | `addVulnerableSoftware(String cpe, String previousVersion)` Adds an entry for vulnerable software.
`int` | `compareTo(Vulnerability v)` Compares two vulnerabilities.
`boolean` | `equals(Object obj)`
`String` | `getCvssAccessComplexity()` Get the value of cvssAccessComplexity.
`String` | `getCvssAccessVector()` Get the value of cvssAccessVector.
`String` | `getCvssAuthentication()` Get the value of cvssAuthentication.
`String` | `getCvssAvailabilityImpact()` Get the value of cvssAvailabilityImpact.
`String` | `getCvssConfidentialityImpact()` Get the value of cvssConfidentialityImpact.
`String` | `getCvssIntegrityImpact()` Get the value of cvssIntegrityImpact.
`float` | `getCvssScore()` Get the value of cvssScore.
`String` | `getCwe()` Get the value of cwe.
`String` | `getDescription()` Get the value of description.
`String` | `getName()` Get the value of name.
`Set<Reference>` | `getReferences()` Get the value of references.
`Set<VulnerableSoftware>` | `getVulnerableSoftware()` Get the value of vulnerableSoftware.
`int` | `hashCode()`
`void` | `setCvssAccessComplexity(String cvssAccessComplexity)` Set the value of cvssAccessComplexity.
`void` | `setCvssAccessVector(String cvssAccessVector)` Set the value of cvssAccessVector.
`void` | `setCvssAuthentication(String cvssAuthentication)` Set the value of cvssAuthentication.
`void` | `setCvssAvailabilityImpact(String cvssAvailabilityImpact)` Set the value of cvssAvailabilityImpact.
`void` | `setCvssConfidentialityImpact(String cvssConfidentialityImpact)` Set the value of cvssConfidentialityImpact.
`void` | `setCvssIntegrityImpact(String cvssIntegrityImpact)` Set the value of cvssIntegrityImpact.
`void` | `setCvssScore(float cvssScore)` Set the value of cvssScore.
`void` | `setCwe(String cwe)` Set the value of cwe.
`void` | `setDescription(String description)` Set the value of description.
`void` | `setName(String name)` Set the value of name.
`void` | `setReferences(SortedSet<Reference> references)` Set the value of references.
`void` | `setVulnerableSoftware(SortedSet<VulnerableSoftware> vulnerableSoftware)` Set the value of vulnerableSoftware.
`boolean` | `updateVulnerableSoftware(VulnerableSoftware vulnSoftware)` Adds or updates a vulnerable software entry.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Vulnerability

    public Vulnerability()

Method Detail

### getName

    public String getName()

  Get the value of name.

  Returns:
    the value of name

### setName

    public void setName(String name)

  Set the value of name.

  Parameters:
    `name` - new value of name

### getDescription

    public String getDescription()

  Get the value of description.

  Returns:
    the value of description

### setDescription

    public void setDescription(String description)

  Set the value of description.

  Parameters:
    `description` - new value of description

### getReferences

    public Set<Reference> getReferences()

  Get the value of references.

  Returns:
    the value of references

### setReferences

    public void setReferences(SortedSet<Reference> references)

  Set the value of references.

  Parameters:
    `references` - new value of references

### addReference

    public void addReference(Reference ref)

  Adds a reference to the references collection.

  Parameters:
    `ref` - a reference for the vulnerability

### addReference

    public void addReference(String referenceSource,
                             String referenceName,
                             String referenceUrl)

  Adds a reference.

  Parameters:
    `referenceSource` - the source of the reference
    `referenceName` - the referenceName of the reference
    `referenceUrl` - the url of the reference

### getVulnerableSoftware

    public Set<VulnerableSoftware> getVulnerableSoftware()

  Get the value of vulnerableSoftware.

  Returns:
    the value of vulnerableSoftware

### setVulnerableSoftware

    public void setVulnerableSoftware(SortedSet<VulnerableSoftware> vulnerableSoftware)

  Set the value of vulnerableSoftware.

  Parameters:
    `vulnerableSoftware` - new value of vulnerableSoftware

### addVulnerableSoftware

    public boolean addVulnerableSoftware(String cpe)

  Adds an entry for vulnerable software.

  Parameters:
    `cpe` - string representation of a CPE entry
  Returns:
    if the add succeeded

### addVulnerableSoftware

    public boolean addVulnerableSoftware(String cpe,
                                         String previousVersion)

  Adds an entry for vulnerable software.

  Parameters:
    `cpe` - string representation of a cpe
    `previousVersion` - the previous version (previousVersion - cpe would be considered vulnerable)
  Returns:
    if the add succeeded

### updateVulnerableSoftware

    public boolean updateVulnerableSoftware(VulnerableSoftware vulnSoftware)

  Adds or updates a vulnerable software entry.

  Parameters:
    `vulnSoftware` - the vulnerable software
  Returns:
    if the update succeeded

### getCwe

    public String getCwe()

  Get the value of cwe.

  Returns:
    the value of cwe

### setCwe

    public void setCwe(String cwe)

  Set the value of cwe.

  Parameters:
    `cwe` - new value of cwe

### getCvssScore

    public float getCvssScore()

  Get the value of cvssScore.

  Returns:
    the value of cvssScore

### setCvssScore

    public void setCvssScore(float cvssScore)

  Set the value of cvssScore.

  Parameters:
    `cvssScore` - new value of cvssScore

### getCvssAccessVector

    public String getCvssAccessVector()

  Get the value of cvssAccessVector.

  Returns:
    the value of cvssAccessVector

### setCvssAccessVector

    public void setCvssAccessVector(String cvssAccessVector)

  Set the value of cvssAccessVector.

  Parameters:
    `cvssAccessVector` - new value of cvssAccessVector

### getCvssAccessComplexity

    public String getCvssAccessComplexity()

  Get the value of cvssAccessComplexity.

  Returns:
    the value of cvssAccessComplexity

### setCvssAccessComplexity

    public void setCvssAccessComplexity(String cvssAccessComplexity)

  Set the value of cvssAccessComplexity.

  Parameters:
    `cvssAccessComplexity` - new value of cvssAccessComplexity

### getCvssAuthentication

    public String getCvssAuthentication()

  Get the value of cvssAuthentication.

  Returns:
    the value of cvssAuthentication

### setCvssAuthentication

    public void setCvssAuthentication(String cvssAuthentication)

  Set the value of cvssAuthentication.

  Parameters:
    `cvssAuthentication` - new value of cvssAuthentication

### getCvssConfidentialityImpact

    public String getCvssConfidentialityImpact()

  Get the value of cvssConfidentialityImpact.

  Returns:
    the value of cvssConfidentialityImpact

### setCvssConfidentialityImpact

    public void setCvssConfidentialityImpact(String cvssConfidentialityImpact)

  Set the value of cvssConfidentialityImpact.

  Parameters:
    `cvssConfidentialityImpact` - new value of cvssConfidentialityImpact

### getCvssIntegrityImpact

    public String getCvssIntegrityImpact()

  Get the value of cvssIntegrityImpact.

  Returns:
    the value of cvssIntegrityImpact

### setCvssIntegrityImpact

    public void setCvssIntegrityImpact(String cvssIntegrityImpact)

  Set the value of cvssIntegrityImpact.

  Parameters:
    `cvssIntegrityImpact` - new value of cvssIntegrityImpact

### getCvssAvailabilityImpact

    public String getCvssAvailabilityImpact()

  Get the value of cvssAvailabilityImpact.

  Returns:
    the value of cvssAvailabilityImpact

### setCvssAvailabilityImpact

    public void setCvssAvailabilityImpact(String cvssAvailabilityImpact)

  Set the value of cvssAvailabilityImpact.

  Parameters:
    `cvssAvailabilityImpact` - new value of cvssAvailabilityImpact

### equals

    public boolean equals(Object obj)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(Vulnerability v)

  Compares two vulnerabilities.

  Specified by:
    `compareTo` in interface `Comparable<Vulnerability>`
  Parameters:
    `v` - a vulnerability to be compared
  Returns:
    a negative integer, zero, or a positive integer as this object is less than, equal to, or greater than the specified vulnerability

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2012-2013 OWASP. All Rights Reserved.